# OpenLayers.Protocol.WFS.v1

Abstract class for for v1.0.0 and v1.1.0 protocol.

#### Inherits from

- OpenLayers.Protocol

Summary

OpenLayers.Protocol.WFS.v1 | Abstract class for for v1.0.0 and v1.1.0 protocol.
Properties |
version | {String} WFS version number.
srsName | {String} Name of spatial reference system.
featureType | {String} Local feature typeName.
featureNS | {String} Feature namespace.
geometryName | {String} Name of the geometry attribute for features.
schema | {String} Optional schema location that will be included in the schemaLocation attribute value.
featurePrefix | {String} Namespace alias for feature type.
formatOptions | {Object} Optional options for the format.
readFormat | {OpenLayers.Format} For WFS requests it is possible to get a different output format than GML.
readOptions | {Object} Optional object to pass to format’s read.
Constructor |
OpenLayers.Protocol.WFS | A class for giving layers WFS protocol.
Functions |
destroy | Clean up the protocol.
read | Construct a request for reading new features.
setFeatureType | Change the feature type on the fly.
setGeometryName | Sets the geometryName option after instantiation.
handleRead | Deal with response from the read request.
parseResponse | Read HTTP response body and return features
commit | Given a list of feature, assemble a batch request for update, create, and delete transactions.
handleCommit | Called when the commit request returns.
filterDelete | Send a request that deletes all features by their filter.
abort | Abort an ongoing request, the response object passed to this method must come from this protocol (as a result of a read, or commit operation).

### Properties

### version

{String} WFS version number.

### srsName

{String} Name of spatial reference system. Default is “EPSG:4326”.

### featureType

{String} Local feature typeName.

### featureNS

{String} Feature namespace.

### geometryName

{String} Name of the geometry attribute for features. Default is “the_geom” for WFS version 1.0, and null for higher versions.

### schema

{String} Optional schema location that will be included in the schemaLocation attribute value. Note that the feature type schema is required for a strict XML validator (on transactions with an insert for example), but is not required by the WFS specification (since the server is supposed to know about feature type schemas).

### featurePrefix

{String} Namespace alias for feature type. Default is “feature”.

### formatOptions

{Object} Optional options for the format. If a format is not provided, this property can be used to extend the default format options.

### readFormat

{OpenLayers.Format} For WFS requests it is possible to get a different output format than GML. In that case, we cannot parse the response with the default format (WFST) and we need a different format for reading.

### readOptions

{Object} Optional object to pass to format’s read.

### Constructor

### OpenLayers.Protocol.WFS

A class for giving layers WFS protocol.

#### Parameters

options | {Object} Optional object whose properties will be set on the instance.

#### Valid options properties

url | {String} URL to send requests to (required).
featureType | {String} Local (without prefix) feature typeName (required).
featureNS | {String} Feature namespace (required, but can be autodetected during the first query if GML is used as readFormat and featurePrefix is provided and matches the prefix used by the server for this featureType).
featurePrefix | {String} Feature namespace alias (optional - only used for writing if featureNS is provided). Default is ‘feature’.
geometryName | {String} Name of geometry attribute. The default is ‘the_geom’ for WFS version 1.0, and null for higher versions. If null, it will be set to the name of the first geometry found in the first read operation.
multi | {Boolean} If set to true, geometries will be casted to Multi geometries before they are written in a transaction. No casting will be done when reading features.

### Functions

### destroy

> destroy: function()

Clean up the protocol.

### read

> read: function( | options | )

Construct a request for reading new features. Since WFS splits the basic CRUD operations into GetFeature requests (for read) and Transactions (for all others), this method does not make use of the format’s read method (that is only about reading transaction responses).

#### Parameters

options | {Object} Options for the read operation, in addition to the options set on the instance (options set here will take precedence).

To use a configured protocol to get e.g. a WFS hit count, applications could do the following:

>     protocol.read({
>         readOptions: {output: "object"},
>         resultType: "hits",
>         maxFeatures: null,
>         callback: function(resp) {
>             // process resp.numberOfFeatures here
>         }
>     });

To use a configured protocol to use WFS paging (if supported by the server), applications could do the following:

>     protocol.read({
>         startIndex: 0,
>         count: 50
>     });

To limit the attributes returned by the GetFeature request, applications can use the propertyNames option to specify the properties to include in the response:

>     protocol.read({
>         propertyNames: ["DURATION", "INTENSITY"]
>     });

### setFeatureType

> setFeatureType: function( | featureType | )

Change the feature type on the fly.

#### Parameters

featureType | {String} Local (without prefix) feature typeName.

### setGeometryName

> setGeometryName: function( | geometryName | )

Sets the geometryName option after instantiation.

#### Parameters

geometryName | {String} Name of geometry attribute.

### handleRead

> handleRead: function( | response,
> | options | )

Deal with response from the read request.

#### Parameters

response | {OpenLayers.Protocol.Response} The response object to pass to the user callback.
options | {Object} The user options passed to the read call.

### parseResponse

> parseResponse: function( | request,
> | options | )

Read HTTP response body and return features

#### Parameters

request | {XMLHttpRequest} The request object
options | {Object} Optional object to pass to format’s read

#### Returns

{Object} or {Array({OpenLayers.Feature.Vector})} or {OpenLayers.Feature.Vector} An object with a features property, an array of features or a single feature.

### commit

> commit: function( | features,
> | options | )

Given a list of feature, assemble a batch request for update, create, and delete transactions. A commit call on the prototype amounts to writing a WFS transaction - so the write method on the format is used.

#### Parameters

features | {Array(OpenLayers.Feature.Vector)}
options | {Object}

#### Valid options properties

nativeElements | {Array({Object})} Array of objects with information for writing out <Native> elements, these objects have vendorId, safeToIgnore and value properties. The <Native> element is intended to allow access to vendor specific capabilities of any particular web feature server or datastore.

#### Returns

{OpenLayers.Protocol.Response} A response object with a features property containing any insertIds and a priv property referencing the XMLHttpRequest object.

### handleCommit

> handleCommit: function( | response,
> | options | )

Called when the commit request returns.

#### Parameters

response | {OpenLayers.Protocol.Response} The response object to pass to the user callback.
options | {Object} The user options passed to the commit call.

### filterDelete

> filterDelete: function( | filter,
> | options | )

Send a request that deletes all features by their filter.

#### Parameters

filter | {OpenLayers.Filter} filter

### abort

> abort: function( | response | )

Abort an ongoing request, the response object passed to this method must come from this protocol (as a result of a read, or commit operation).

#### Parameters

response | {OpenLayers.Protocol.Response}

Base class for format reading/writing a variety of formats.

> destroy: function()

Clean up the protocol.

> read: function( | options | )

Construct a request for reading new features.

> setFeatureType: function( | featureType | )

Change the feature type on the fly.

> setGeometryName: function( | geometryName | )

Sets the geometryName option after instantiation.

> handleRead: function( | response,
> | options | )

Deal with response from the read request.

> parseResponse: function( | request,
> | options | )

Read HTTP response body and return features

> commit: function( | features,
> | options | )

Given a list of feature, assemble a batch request for update, create, and delete transactions.

> handleCommit: function( | response,
> | options | )

Called when the commit request returns.

> filterDelete: function( | filter,
> | options | )

Send a request that deletes all features by their filter.

> abort: function( | response | )

Abort an ongoing request, the response object passed to this method must come from this protocol (as a result of a read, or commit operation).
Abstract vector layer protocol class.
{String} WFS version number.
Protocols return Response objects to their users.
Vector features use the OpenLayers.Geometry classes as geometry description.
Close